//+------------------------------------------------------------------+
//|                                                      SellOne.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//---- Includes
#include <stdlib.mqh>
#include <gMail.mqh>

//---- input parameters
extern string    TradeType = "b"; // for buy, "s" for sell,"bs" for buy stop,"bl" for buy limit,"ss"  for sell stop,"sl" for sell limit,
extern int   pipdiff =3;
double    Lots = 0.1; 
extern string    Comm1 = "a";
extern bool      useSendMail = false;
extern string    disaster_SL1="010"; //this is not used now - but can be used later
extern string    fictional_SL1="010"; // this is actually the SL now
extern string    TP_1 ="010";
extern string body1="Reason";
extern int MAGICMA = 8032132;
extern int    TradeTime=2; //local time at which the stop will erase if not Entered.
static double    Enter=0;
extern int       Slippage = 1;
extern bool      Show_Settings=true;
//Global
static double disaster_SL,fictional_SL,TP1,tp1,tp2,tp3,DisasterSL,fictionalSL, BE;

static bool Stopped = false,CheckBE=false,checked = false;
int      NumberOfTries = 5;
string   ExpertComment = "TradeOne";
static double LotsDefault=0.1;
static int ticket=0,BuySell = OP_BUY;

string gvname;
extern string s2 = "Settings for MM using pct";
extern bool MM_pct = true;
extern double risk_pct = 1;

extern bool brokerIBFX = true;
extern bool AccIsmini = false;

extern string s4 = "Settings Pip prices if using MM using pct";
extern double EurUsd_p = 10;//1
extern double GbpUsd_p = 10;//1
extern double UsdJpy_p = 8.8;//
extern double EurJpy_p = 6.88;//
extern double UsdChf_p = 8.2;//
extern double UsdCad_p = 9.01;//
extern double AUDUsd_p = 10;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
disaster_SL=StrToInteger(disaster_SL1);
fictional_SL=StrToInteger(fictional_SL1);
TP1=StrToInteger(TP_1);
ExpertComment = Comm1 + disaster_SL1 + TP_1;


   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   //--- Trading conditions
  bool BuyCondition = false , SellCondition = false , CloseBuyCondition = false , CloseSellCondition = false ; 
  int Crossed=0;
   
 if (ScanTrades()>0)
{
 //Check for exit
  // ExitStratergy();
   //Alert("scantrades stopped, symbol: ", Symbol(),Period());
   return(0); //no more trades
}
 
        
if (Stopped==true) //this is redundant as the top one will catch 
{
 //do nothing
 // Alert("stopped," Symbol(),Period());
 return(0);
}
       

if (checked == false)
{

  TradeTime = CurTime()+ TradeTime*3600;
  if (TradeType=="b") {BuySell = OP_BUY; checked = true;}
  if (TradeType=="bs"){BuySell = OP_BUY; Enter = Ask+pipdiff*Point;checked = true;}
  if (TradeType=="bl"){BuySell = OP_BUY; Enter = Ask-pipdiff*Point;checked = true;}
  if (TradeType=="s") {BuySell = OP_SELL; checked = true;}
  if (TradeType=="ss"){BuySell = OP_SELL; Enter = Bid-pipdiff*Point;checked = true;}
  if (TradeType=="ss"){BuySell = OP_SELL; Enter = Bid-pipdiff*Point;checked = true;}
         
  
  
  
if(Show_Settings) Print_Details();

   
  
 // Alert("checked=true "," curtime: ",CurTime()," ,Tradetime: ",TradeTime, " MAGICNO: ",MAGICMA);
}

 //Stop at the right time
   if(CurTime()>= TradeTime)
   {
     return(0);
   }
       

 
        if (BuySell == 0)  //Buy type
        {

          if (TradeType=="b")
          {
            BuyCondition =true;
          }

          Crossed =CrossedEnter(Ask,Enter);
          
          if ((Crossed==1)&& (TradeType=="bs"))
          {
            BuyCondition =true;
          }
          
          if ((Crossed==2)&& (TradeType=="bl"))
          {
            BuyCondition =true;
          }
          
        }
        else //must be selling
        {

          if (TradeType=="s")
          {
            SellCondition =true;
          }

          Crossed = CrossedEnter(Bid,Enter);
          if ((Crossed==2) && (TradeType=="ss"))
          {
            SellCondition =true;
          }
          if ((Crossed==1) && (TradeType=="sl"))
          {
            SellCondition =true;
          }
        }
  
         if(BuyCondition) //<-- BUY condition
         {
           ticket = OpenOrder(OP_BUY); //<-- Open BUY order
         }
         if(SellCondition) //<-- SELL condition
         {
            ticket = OpenOrder(OP_SELL); //<-- Open SELL order
         }
 
//----
   return(0);
  }
//+------------------------------------------------------------------+

int OpenOrder(int type)
{

   int err=0;
   int c = 0;
   string title1;
  
   
   Lots = calcLots();  //determine the lots
   
   if(type==OP_BUY)
   {
      for(c = 0 ; c < NumberOfTries ; c++)
      {
         double ask1 = Ask;
         fictionalSL = NormalizeDouble(ask1-fictional_SL*Point,Digits);
         tp1 = NormalizeDouble(ask1+TP1*Point,Digits);
         ticket=OrderSend(Symbol(),OP_BUY,Lots,ask1,Slippage,0,0,ExpertComment,MAGICMA,0,Green);
   
         err=GetLastError();
         
         if(err==0)
         { 
            if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
            {

              BE = NormalizeDouble(ask1+2*Point,Digits);
              DisasterSL = NormalizeDouble(ask1-disaster_SL*Point,Digits);
              //SendOne(string Subject1, string Body1)
              title1 =  MAGICMA + ": T1 buy OrderOpened " + Symbol() + " "  +TimeToStr(LocalTime(),TIME_DATE|TIME_SECONDS);
              SendOne(title1, body1,useSendMail);
              Stopped = true;
            }
            break;
         }
         else
         {
            if(err==4 || err==137 ||err==146 || err==136) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               Print("Error opening BUY order : ", ErrorDescription(err));
               break;
            }  
         }
      }   
   }
   if(type==OP_SELL)
   {   
      for(c = 0 ; c < NumberOfTries ; c++)
      {
         double Bid1 = Bid;
         tp1 = NormalizeDouble(Bid1-TP1*Point,Digits);
         BE = NormalizeDouble(Bid1-2*Point,Digits);
         fictionalSL = NormalizeDouble(Bid1-fictional_SL*Point,Digits);
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid1,Slippage,0,0,ExpertComment,MAGICMA,0,Red);
         err=GetLastError();
         if(err==0)
         { 
           if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
            {
              DisasterSL = NormalizeDouble(Bid1-disaster_SL*Point,Digits);
              title1 =  MAGICMA + ": "+"T1 Sell OrderOpened " + Symbol()+ " "  +TimeToStr(LocalTime(),TIME_DATE|TIME_SECONDS);
              SendOne(title1, body1,useSendMail);
              Stopped = true;
            }
            break;
         }
         else
         {
            
            if(err==4 || err==137 ||err==146 || err==136) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               Print("Error opening SELL order : ", ErrorDescription(err));
              Alert("Error opening SELL order : ", ErrorDescription(err));
               break;
            }  
         }
      }   
   } 
   return(ticket);
}

bool CloseOrder(int type)
{
   Print("Asked to close!");
   if(OrderMagicNumber() == MAGICMA)
   {
      if(type==OP_BUY)
         return (OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet));
      if(type==OP_SELL)   
         return (OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet));
   }
}

//Crossed (SEma,LEma);
int CrossedEnter (double line1 , double line2)
   {
       int last_direction = 0;
      int current_direction = 0;
      gvname = "ldent" + MAGICMA;
      if(GlobalVariableCheck(gvname)) 
      {
       last_direction = GlobalVariableGet(gvname);
      }
      else
      {
       last_direction=0;
       GlobalVariableSet(gvname,0);
      }
      
      gvname = "cdent" + MAGICMA;
      if(GlobalVariableCheck(gvname)) 
      {
       current_direction = GlobalVariableGet(gvname);
      }
      else
      {
       current_direction=0;
       GlobalVariableSet(gvname,0);
      }
      
      if(line1>line2)current_direction = 1; //up
      if(line1<line2)current_direction = 2; //down
      
      if(current_direction != last_direction) //changed 
      {
            last_direction = current_direction;
            
            gvname = "cdent" + MAGICMA;
            GlobalVariableSet(gvname,current_direction);
            gvname= "ldent" + MAGICMA;
            GlobalVariableSet(gvname,last_direction);
            
            return (last_direction);
      }
      else
      {
            return (0); //not changed
      }
   }


   
// ---- Scan Trades
int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
   int cnt;
      
   for(cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()>=OP_BUY && OrderMagicNumber() == MAGICMA) 
   numords++;
   }
   return(numords);
}


/////////////////////////////////////////////
void CloseAll()
{
    CloseAllSELL(Symbol(), MAGICMA);
    CloseAllBUY(Symbol(), MAGICMA);
    return;
} 

void CloseAllBUY(string symbol1, int MagicNum1)
{
     int total, cnt,i;
     bool result = false;
     RefreshRates();
//check if any open positions need to be closed
     for(i = 0; i < OrdersTotal(); i ++)   
   {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderSymbol()!= symbol1 || OrderMagicNumber() != MagicNum1) continue;     
    
      if (OrderType() == OP_BUY) result = OrderClose(OrderTicket(),OrderLots(),Bid,3,Pink);
      if (OrderType() == OP_BUYSTOP) result = OrderDelete( OrderTicket() );
   }
 return;
} 


/////////////////////////////////////////////
void CloseAllSELL(string symbol1, int MagicNum1)
{
     int total, cnt,i;
     bool result = false;
     RefreshRates();
//check if any open positions need to be closed
     for(i = 0; i < OrdersTotal(); i ++)   
   {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderSymbol()!= symbol1 || OrderMagicNumber() != MagicNum1) continue;     
    
      if (OrderType() == OP_SELL) result = OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet);
      if (OrderType() == OP_SELLSTOP) result = OrderDelete( OrderTicket() );
   }
 return(0);
} 


//////////////////////////////////////////////////////////////////////////////////////
int EA_Tot_buyorders(string Symbol1, int magicEA)
{
   int SellCount = 0;
   int BuyCount = 0;
   int SellLimitCount = 0; 
   int BuyLimitCount = 0;
   int SellStopCount =0;
   int BuyStopCount =0;
   int i;
   	
   for(i = 0; i < OrdersTotal(); i ++)   
   {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderSymbol()!= Symbol1 || OrderMagicNumber() != magicEA) continue;     
      if (OrderType() == OP_BUY) BuyCount ++;
      if (OrderType() == OP_SELL) SellCount ++;
      if (OrderType() == OP_BUYLIMIT) BuyLimitCount ++;
      if (OrderType() == OP_SELLLIMIT) SellLimitCount ++;
      if (OrderType() == OP_BUYSTOP) BuyStopCount ++;
      if (OrderType() == OP_SELLSTOP) SellStopCount ++;
   }
  i = BuyCount;
  return(i);
}
//////////////////////////////////////////////////////////////////////////////////////
int EA_Tot_sellorders(string Symbol1, int magicEA)
{
   int SellCount = 0;
   int BuyCount = 0;
   int SellLimitCount = 0; 
   int BuyLimitCount = 0;
   int SellStopCount =0;
   int BuyStopCount =0;
   int i;
   	
   for(i = 0; i < OrdersTotal(); i ++)   
   {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderSymbol()!= Symbol1 || OrderMagicNumber() != magicEA) continue;     
      if (OrderType() == OP_BUY) BuyCount ++;
      if (OrderType() == OP_SELL) SellCount ++;
      if (OrderType() == OP_BUYLIMIT) BuyLimitCount ++;
      if (OrderType() == OP_SELLLIMIT) SellLimitCount ++;
      if (OrderType() == OP_BUYSTOP) BuyStopCount ++;
      if (OrderType() == OP_SELLSTOP) SellStopCount ++;
   }
  i = SellCount;
  return(i);
}   
/////////////////////////////////////////////


////////////////////////////////////////////////

double calcLots()
{
     Lots = LotsDefault;
     
      
      if (MM_pct==true)
      {
       Lots = Lotsize2(fictional_SL, risk_pct, Symbol(), AccIsmini,brokerIBFX); 
      }
      
        if (AccIsmini)
       {
        Print("Lots : ", Lots,", Cost : ", Lots*100);
       }
       else 
       {
       Print("Lots : ", Lots,", Cost : ", Lots*1000);
       }
       
     return(Lots);
}
////////////////////////////

/////////////////////////////////////////////////////////////////////////////////
double Lotsize2(int stoploss1, double risk1, string symbol1, bool miniAcc,bool broker)
{
/* returns the number of lots one can buy for a certain symbol 
 * for a given risk level and stoploss. Returns Max 100 lots.
 * The pip values for the function come from http://www.interbankfx.com/calculator.htm
 * if you use a currency other then the dollar - get your own values.
 * Inputs
 * 1 stoploss1 - what is your stoploss i,e, 10, 20, 30 etc pips, ensure that trailingstop is
 *              - less then stoploss1
 * 2 risk1 - how much of your accounts free margin are you willing to loss
 *         0.03 for 3%, 0.1 for 10%
 * 3 std_or_mini - Enter "std" for a standard or demo account, where the minimum transaction size is
 * 				   1 lot of 100,000 of the base currency or Enter 
 * 				   "mini" - where the minimum transaction size is 1/10th 
 *                  the size of a standard lot, or 10,000 of the base currency.  
 * 4 symbol2 : the symbol your dealing with e.i. "EURUSD"
 * The function determines how much of your account you already have at risk
 * by calculating what you would lose if all your current stops and open orders hit their S/L
 * it ensure that you can trade risk1% of your total account if your account freeMargin - all open orders is greater then 20%
 * is greater
 * then your accounts leverage
 * and returns the number of lots that you can then purchase
 */

double AccountLeverage1; //the leverage of the current account
double pip; //one pip price - from http://www.interbankfx.com/calculator.htm
            //this changes automatically based on either 'std' or 'mini'
double lots1;   

string broker1;

//modification for HH
static int i1=1;
static double AFM;
/*
if (hhtrade ==1)
 {
   AFM = AccountFreeMargin();
 }
*/

//tocheck: before attaching EA - are your symbol definitions right?

  //
  pip = pipprice(symbol1,miniAcc,broker);
  
  //TODO: Don't loss more then risk% of AccountFreeMargin - not working right now
  
  lots1 = NormalizeDouble(((AccountFreeMargin()/(stoploss1*pip))*(risk1/100)),1);
  Print("Calculated lots : ",lots1, " Symbol: ", Symbol(),", stoploss : ", stoploss1, " pipPrice : ", pip,", Risk% : ", risk1," ,AccountfreeMarg: ", AccountFreeMargin(), " MaxLoss: ",lots1*stoploss1*pip);	


if (miniAcc == true)
{
//	Print("Hi in Lots1 ibfx mini");
  if  (lots1 > 50)
  {
	lots1 = 50;
	return(lots1);
  }

	return(lots1);
  }
  else  //this is the case for std accounts
  {
   
  if  (lots1 > 100)
  {
    lots1 = 100;
    return(lots1);
  }
	return(lots1);
 }
}
/////////////////////////////////////////
///////////////////////
double pipprice(string symbol1,bool miniAcc,bool broker)
{
double AccountLeverage1; //the leverage of the current account
double pip; //one pip price - from http://www.interbankfx.com/calculator.htm
string broker1;


//tocheck: before attaching EA - are your symbol definitions right?
 AccountLeverage1 = AccountLeverage();
 
if (brokerIBFX == true && miniAcc == true)
{
  Print("Hi in Lots1 ibfx mini");
  if(symbol1 == "EURUSDm" || symbol1 == "GBPUSDm")
  {
    pip = EurUsd_p/10;
    return(pip);
  }
  else if(symbol1 == "USDCHFm")
  {
    pip = UsdChf_p/10;
    return(pip);
  }
  else if(symbol1 == "USDJPYm")
  {
    pip = UsdJpy_p/10; 
    return(pip);
  }
  else if(symbol1 == "EURJPYm")
  {
    pip = EurJpy_p/10; 
    return(pip);
  }
  else if(symbol1 == "USDCADm")
  {
    pip = UsdCad_p/10; 
    return(pip);
  }
  else if(symbol1 == "AUDUSDm")
  {
    pip = AUDUsd_p/10; 
    return(pip);
  }
  
   //TODO: Actually if it can't find the right symbol - fail gracefully.
  else return(0);// problem - just expand to include all symbols trading with

 
  
}
  else  //this is the case for  std account and accounts at other brokerages
  {

   if(symbol1 == "EURUSD" || symbol1 == "GBPUSD")
   {
    pip = EurUsd_p;
   }
   else if(symbol1 == "USDCHF")
   {
     pip = UsdChf_p;
   }
   else if(symbol1 == "USDJPY")
   {
    pip = UsdJpy_p; 
    }
  else if(symbol1 == "EURJPY")
  {
    pip = EurJpy_p; 
    return(pip);
  }
  else if(symbol1 == "USDCAD")
  {
    pip = UsdCad_p; 
    return(pip);
  }
  else if(symbol1 == "AUDUSD")
  {
    pip = AUDUsd_p; 
    return(pip);
  }
 
   //TODO: Actually if it can't find the right symbol - fail gracefully.
   else return(0);// problem - just expand to include all symbols trading with


   if (miniAcc == true) // transaction size is 1/10th the size of a standard lot
   {
    pip = pip/10;
   }

   AccountLeverage1 = AccountLeverage();
   //pip = pip;
   return(pip);
}
}

bool SendOne(string Subject1, string Body1, bool useSendMail1)
 {
  
  if (!useSendMail1) return(0);
  
   string Profile = "sbw252000";
   string To = "new_options@hotmail.com";
   string Subject = Subject1;
   string Body = Body1;
   string Attachmet = "C:\Program Files\Interbank FX Trader 4\experts\files\ss.gif";
   string Attachmet_Title = "Screen Shot.gif";
   
   if(ScreenShot("ss.gif",640,480))
      bool reuslt = gSendMail(Profile,To,Subject,Body,Attachmet,Attachmet_Title);
   return(0);
  }

/////////
void Print_Details()
{
   string sComment = "";
   string sp = "----------------------------------------\n";
   string NL = "\n";

   sComment = sp;
   sComment = sComment + "Symbol=" + Symbol() + " | ";
   sComment = sComment + "BuySell=" + BuySell + " | ";
   sComment = sComment + "Enter=" + Enter + " | ";
   if (tp1>0) sComment = sComment + "TakeProfit=" + DoubleToStr(tp1,0) + " | ";
   
  
   Comment(sComment);
}

